package com.bonus.file.service.impl;

import com.alibaba.nacos.common.utils.IoUtils;
import com.bonus.common.core.utils.file.FileTypeUtils;
import com.bonus.common.core.utils.file.MimeTypeUtils;
import com.bonus.file.entity.FileDetails;
import com.bonus.file.service.ISysFileService;
import com.bonus.file.utils.FileUploadUtils;
import com.bonus.system.api.domain.SysFile;
import com.github.tobato.fastdfs.domain.fdfs.StorePath;
import com.github.tobato.fastdfs.service.FastFileStorageClient;
import org.apache.commons.io.IOUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.InputStream;
import java.net.URLEncoder;
import java.nio.charset.StandardCharsets;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Set;

/**
 * FastDFS 文件存储
 *
 * @author bonus
 */
@Service
@ConditionalOnProperty(name = "storage.type", havingValue = "fdfs")
public class FastDfsSysFileServiceImpl implements ISysFileService
{
    /**
     * 域名或本机访问地址
     */
    @Value("${fdfs.domain}")
    public String domain;

    @Autowired
    private FastFileStorageClient storageClient;

    /**
     * FastDfs文件上传接口
     *
     * @param file 上传的文件
     * @return 访问地址
     * @throws Exception
     */
    @Override
    public SysFile uploadFile(MultipartFile file) throws Exception
    {
        //验证文件扩展名是否合法
        FileUploadUtils.assertAllowed(file, MimeTypeUtils.DEFAULT_ALLOWED_EXTENSION);

        String fileName = FileUploadUtils.extractFilename(file);
        InputStream inputStream = file.getInputStream();
        StorePath storePath = storageClient.uploadFile(inputStream, file.getSize(),
                FileTypeUtils.getExtension(file), null);
        IoUtils.closeQuietly(inputStream);
        return SysFile.builder().url(domain + "/" + storePath.getFullPath()).name(fileName).build();
    }

    @Override
    public List<SysFile> uploadFiles(MultipartFile[] files) throws Exception {
        List<SysFile> sysFiles = new ArrayList<>();
        for (MultipartFile file : files) {
            SysFile sysFile = uploadFile(file);
            sysFiles.add(sysFile);
        }
        return sysFiles;
    }

    /**
     * FastDfs文件下载接口，待测试
     *
     * @param response 响应对象
     * @param urlStr   文件URL地址
     * @return 是否下载成功
     */
    @Override
    public void downloadFile(HttpServletResponse response, String urlStr) throws Exception
    {
        try {
            String path = urlStr.replace(domain + "/", "");
            StorePath storePath = StorePath.parseFromUrl(path);

            // 下载文件并返回输入流
            byte[] fileData = storageClient.downloadFile(storePath.getGroup(), storePath.getPath(), IOUtils::toByteArray);

            // 设置响应头
            String encodedFileName = URLEncoder.encode(storePath.getPath(), StandardCharsets.UTF_8.toString());
            response.setContentType("application/octet-stream");
            response.setHeader("Content-Disposition", "attachment; filename=\"" + storePath.getPath() + "\"");

            // 将文件内容写入响应
            IOUtils.write(fileData, response.getOutputStream());
            response.flushBuffer();
        } catch (Exception e) {
            throw new Exception("Error occurred while downloading file from FastDfs" + urlStr, e);
        }
    }

    @Override
    public String getFullFileUrl(String urlStr) throws Exception {
        return urlStr;
    }

    /**
     * 从给定的URL下载文件并将其保存到指定的目标位置。
     *
     * @param response 请求响应。
     * @param urlStr   要下载文件的URL地址。
     * @throws Exception 如果在下载过程中遇到任何异常，例如网络问题、文件写入问题等。
     */
    @Override
    public void downloadFilesAsZip(HttpServletResponse response, List<String> urlStr) throws Exception {

    }

    /**
     * FastDfs文件删除接口，待测试
     *
     * @param urlStr 文件URL地址
     * @return 是否删除成功
     */
    @Override
    public void deleteFile(String urlStr) throws Exception
    {
        try {
            // 从 URL 中提取文件路径
            String path = urlStr.replace(domain + "/", "");
            StorePath storePath = StorePath.parseFromUrl(path);

            // 删除文件
            storageClient.deleteFile(storePath.getGroup(), storePath.getPath());
        } catch (Exception e) {
            throw new Exception("Error occurred while deleting file from FastDfs" + urlStr, e);
        }
    }

    /**
     * 删除指定URL所指向的文件。
     *
     * @param urlStr 要删除文件的URL地址。
     * @return 布尔值，指示文件删除是否成功。如果文件被成功删除，则返回true；否则返回false。
     * @throws Exception 如果在删除文件的过程中遇到错误，例如网络问题、文件不存在或没有删除权限等。
     */
    @Override
    public void deleteFiles(List<String> urlStr) throws Exception {

    }

    /**
     * 获取指定文件夹下的所有文件夹和文件。
     *
     * @param folderPath 要获取文件夹和文件的父文件夹路径（例如 "folder1/"）
     * @return 返回一个包含所有文件夹和文件路径的集合
     */
    @Override
    public Set<FileDetails> getFilesAndSubfolders(String folderPath) {
        return Collections.emptySet();
    }

    /**
     * 创建文件夹（通过上传带有路径的文件）
     *
     * @param folderPath 文件夹路径（例如 "folder1/subfolder/"）
     */
    @Override
    public void createFolder(String folderPath) {

    }

    /**
     * 删除指定路径的所有对象，从而删除“文件夹”。
     *
     * @param folderPath 文件夹路径（例如 "folder1/subfolder/"）
     */
    @Override
    public void deleteFolder(String folderPath) {

    }
}
